import java.util.Random;
import java.util.Iterator;
import java.util.NoSuchElementException;

public class HashUSet<E> implements SimpleUSet<E> {
    public static final int DEFAULT_LOG_CAPACITY = 4;
    
    protected int logCapacity = DEFAULT_LOG_CAPACITY; // value d from lecture
    protected int capacity = 1 << logCapacity;        // n = 2^d
    protected int size = 0;
    protected Object[] table;                         // array of heads of linked lists

    // final = can't be changed after initial assignment!
    protected final int z;

    public HashUSet() {
	// set capacity to 2^logCapacity
	int capacity = 1 << logCapacity;
	
	table = new Object[capacity];

	// add a sentinel node to each list in the table
	for (int i = 0; i < capacity; ++i) {
	    table[i] = new Node<E>(null);
	}

	// fix a random odd integer
	Random r = new Random();	
	z = (r.nextInt() << 1) + 1;
    }
    
    @Override
    public int size() {
	return this.size;
    }

    @Override
    public boolean isEmpty() {
	return this.size == 0;
    }

    @Override
    @SuppressWarnings("unchecked")
    public boolean add(E x) {
	/*
	 * COMPLETE THIS METHOD
	 */

	return false;
    }

    @Override
    @SuppressWarnings("unchecked")
    public E remove(E x) {

	/*
	 * COMPLETE THIS METHOD
	 */

	return null;
    }

    @Override
    @SuppressWarnings("unchecked")
    public E find(E x) {

	/*
	 * COMPLETE THIS METHOD
	 */
	
	return null;
    }

    protected int getIndex(E x) {
	// get the first logCapacity bits of z * x.hashCode()
	return ((z * x.hashCode()) >>> 32 - logCapacity);
    }

    // @SuppressWarnings("unchecked")
    // protected void increaseCapacity() {
	
    // 	logCapacity += 1;
    // 	capacity = capacity << 1;

    // 	// store the old hash table
    // 	Object[] oldTable = table;

    // 	// make a new new has table and initialize it
    // 	table = new Object[capacity];

    // 	// add old lists to new table
    // 	for (int i = 0; i < oldTable.length; ++i) {
    // 	    table[i] = oldTable[i];	    
    // 	}

    // 	// add sentinel nodes to new table
    // 	for (int i = oldTable.length; i < table.length; ++i) {
    // 	    table[i] = new Node<E>(null);
    // 	}
    // }

    @SuppressWarnings("unchecked")
    protected void increaseCapacity() {	
    	logCapacity += 1;
    	capacity = capacity << 1;

    	// store the old hash table
    	Object[] oldTable = table;

    	// make a new new has table and initialize it
    	table = new Object[capacity];
	    
    	for (int i = 0; i < table.length; ++i) {
    	    table[i] = new Node<E>(null);
    	}

    	// reset the size to 0 since it will get incremented when we
    	// add elements to the new table
    	size = 0;

    	// iterate over lists in oldTable and add elements to new table
    	for (int i = 0; i < oldTable.length; ++i) {
    	    Node<E> nd = ((Node<E>)oldTable[i]).next;
    	    while (nd != null) {
    		this.add(nd.value);
    		nd = nd.next;
    	    }
    	}
    }
    
    protected class Node<E> {
	protected Node<E> next = null;
	protected E value;

	public Node(E value) {
	    this.value = value;
	}
    }
}
